/******************************************************************************
 *                                                                            *
 * File:   cpuid   .h         Version  1.10            Date: 1996-08-25       *
 *                                                                            *
 * Copyright (C) 1991-1996 by kostis@acm.org (Kosta Kostis)                   *
 * This program may be used free of charge at your own risk.                  *
 *                                                                            *
 ******************************************************************************
 *                                                                            *
 * History:                                                                   *
 *     1996-08-25: KK V1.10                                                   *
 *        - see cpuid.asm                                                     *
 *                                                                            *
 *****************************************************************************/

/******************************************************************************

	Function Return Values

 *****************************************************************************/

#define	P_PentiumPro	6
#define	P_Pentium	5
#define	P_i486		4
#define P_i386		3
#define P_80286		2
#define P_80186		1
#define P_8086		0

#define	P_LAST		P_PentiumPro

/******************************************************************************

	Function Prototypes

 *****************************************************************************/

extern	int	CPUid (void) ;			/* return values see above   */
extern	char	*CPUname (int CPUid) ;		/* ASCIIZ string             */
extern	int	CPUspeed (void) ;		/* approx. speed in MHz      */

extern	int	Time86 (void) ;			/* internal function         */
extern	int	Time386 (void) ;		/* internal function         */

/******************************************************************************

	Function Constants

 *****************************************************************************/

#define	nITERATIONS	20
