;  ***************************************************************************
;  *                                                                         *
;  * File:   TIMEPROC.ASM         Version   1.00           Date: 1993-09-05  *
;  *                                                                         *
;  * Copyright (C) 1993-1996 by kostis@acm.org (Kosta Kostis)                *
;  * This program may be used free of charge at your own risk.               *
;  *                                                                         *
;  ***************************************************************************
;  *                                                                         *
;  * Function:                                                               *
;  *     - test CPU speed                                                    *
;  *                                                                         *
;  ***************************************************************************
;  *                                                                         *
;  * History:                                                                *
;  *     1993-09-05: KK V1.00                                                *
;  *        - initial coding                                                 *
;  *                                                                         *
;  ***************************************************************************

; a little program to detect the Hz rating of a i486 (I hope)

nITERATIONS	EQU	20

.8086
.MODEL		SMALL,C
.CODE

PUBLIC		Time86			; int	Time86 (void)
PUBLIC		Time386			; int	Time386 (void)

; -- timing code for 8086/80186/80286 processors ----------------------

Time86		PROC

		cli

		mov	cx,1234
		xor	dx,dx
		xor	ax,ax

		mov	al,10111000b	; channel 2, LSB+MSB, mode 4, binary
		out	43h,al
		in	al,61h
		or	al,1
		out	61h,al
		xor	al,al
		out	42h,al
		out	42h,al
		xor	ax,ax		; dividing into zero

REPT		nITERATIONS
		idiv	cx
ENDM

		in	al,42h		; MSB
		mov	ah,al
		in	al,42h		; LSB
		xchg	al,ah
		neg	ax

		sti
		ret

Time86		ENDP

; -- timing code for 386/486 processors -----------------------

Time386		PROC

		cli

		mov	al,10111000b	; channel 2, LSB+MSB, mode 4, binary
		out	43h,al
		in	al,61h
		or	al,1
		out	61h,al
		xor	al,al
		out	42h,al
		out	42h,al

.386
		mov	eax,80000000h

REPT	nITERATIONS
		bsf	ecx,eax		; 46 cycles (on a 486)
ENDM

.8086

		in	al,42h		; MSB
		mov	ah,al
		in	al,42h		; LSB
		xchg	al,ah
		neg	ax

		sti
		ret

Time386		ENDP

		END
